#!/usr/bin/env python

# A simple application.


import sys, string
from qt import *
import icons

fileOpenText1 = ("<p><img source=\"fileopen.png\"> "
                "Click this button to open a <em>new file</em>.<br>"
                "You can also select the <b>Open</b> command "
                "from the <b>File</b> menu.</p>")

fileSaveText1 = ("<p><img source=\"filesave.png\"> "
                "Click this button to save the file you "
                "are editing. You will be prompted for a file name.\n"
                "You can also select the <b>Save</b> command "
                "from the <b>File</b> menu.</p>")

filePrintText1 = ("<p><img source=\"fileprint.png\"> "
	         "Click this button to print the file you "
                 "are editing.\n"
		 "You can also select the <b>Print</b> command "
		 "from the <b>File</b> menu.")

fileOpenText2 = ("<p><img source=\"fileopen.xpm\"> "
                "Click this button to open a <em>new file</em>.<br>"
                "You can also select the <b>Open</b> command "
                "from the <b>File</b> menu.</p>")

fileSaveText2 = ("<p><img source=\"filesave.xpm\"> "
                "Click this button to save the file you "
                "are editing. You will be prompted for a file name.\n"
                "You can also select the <b>Save</b> command "
                "from the <b>File</b> menu.</p>")

filePrintText2 = ("<p><img source=\"fileprint.xpm\"> "
	         "Click this button to print the file you "
                 "are editing.\n"
		 "You can also select the <b>Print</b> command "
		 "from the <b>File</b> menu.")

editorList = []


class ApplicationWindow(QMainWindow):
    def __init__(self):
        QMainWindow.__init__(self,None,'example application main window',Qt.WDestructiveClose)

        self.filename = QString.null
        self.printer = QPrinter()

        self.fileTools = QToolBar(self,'file operations')

        self.openIcon1 = QIconSet(QPixmap.fromMimeSource('fileopen.png'))
        self.fileOpen1 = QToolButton(self.openIcon1,'Open File',QString.null,self.load,self.fileTools,'open file')
        self.openIcon2 = QIconSet(QPixmap.fromMimeSource('fileopen.xpm'))
        self.fileOpen2 = QToolButton(self.openIcon2,'Open File',QString.null,self.load,self.fileTools,'open file')

        self.saveIcon1 = QIconSet(QPixmap.fromMimeSource('filesave.png'))
        self.fileSave1 = QToolButton(self.saveIcon1,'Save File',QString.null,self.save,self.fileTools,'save file')
        self.saveIcon2 = QIconSet(QPixmap.fromMimeSource('filesave.xpm'))
        self.fileSave2 = QToolButton(self.saveIcon2,'Save File',QString.null,self.save,self.fileTools,'save file')
	      	      
        self.printIcon1 = QIconSet(QPixmap.fromMimeSource('fileprint.png'))
        self.filePrint1 = QToolButton(self.printIcon1,'Print File',QString.null,self.printDoc,self.fileTools,'print file')
        self.printIcon2 = QIconSet(QPixmap.fromMimeSource('fileprint.xpm'))
        self.filePrint2 = QToolButton(self.printIcon2,'Print File',QString.null,self.printDoc,self.fileTools,'print file')

        QWhatsThis.whatsThisButton(self.fileTools)

        QWhatsThis.add(self.fileOpen1,fileOpenText1)
        QWhatsThis.add(self.fileOpen2,fileOpenText2)
        QWhatsThis.add(self.fileSave1,fileSaveText1)
        QWhatsThis.add(self.fileSave2,fileSaveText2)
        QWhatsThis.add(self.filePrint1,filePrintText1)
        QWhatsThis.add(self.filePrint2,filePrintText2)

        self.file = QPopupMenu(self)
        self.menuBar().insertItem('&File',self.file)

        self.file.insertItem('&New',self.newDoc,Qt.CTRL + Qt.Key_N)

        id = self.file.insertItem(QIconSet(self.openIcon1),'&Open',self.load,Qt.CTRL + Qt.Key_O)
        self.file.setWhatsThis(id,fileOpenText1)
        id = self.file.insertItem(QIconSet(self.openIcon2),'&Open',self.load,Qt.CTRL + Qt.Key_O)
        self.file.setWhatsThis(id,fileOpenText2)

        id = self.file.insertItem(QIconSet(self.saveIcon1),'&Save',self.save,Qt.CTRL + Qt.Key_S)
        self.file.setWhatsThis(id,fileSaveText1)
        id = self.file.insertItem(QIconSet(self.saveIcon2),'&Save',self.save,Qt.CTRL + Qt.Key_S)
        self.file.setWhatsThis(id,fileSaveText2)

        id = self.file.insertItem('Save &as',self.saveAs)
        self.file.setWhatsThis(id,fileSaveText1)

        self.file.insertSeparator()

        id = self.file.insertItem(QIconSet(self.printIcon1),'&Print',self.printDoc,Qt.CTRL + Qt.Key_P)
        self.file.setWhatsThis(id,filePrintText1)
        id = self.file.insertItem(QIconSet(self.printIcon2),'&Print',self.printDoc,Qt.CTRL + Qt.Key_P)
        self.file.setWhatsThis(id,filePrintText2)

        self.file.insertSeparator()

        self.file.insertItem('&Close',self,SLOT('close()'),Qt.CTRL + Qt.Key_W)
        self.file.insertItem('&Quit',qApp,SLOT('closeAllWindows()'),Qt.CTRL + Qt.Key_Q)

        self.help = QPopupMenu(self)
        self.menuBar().insertSeparator()
        self.menuBar().insertItem('&Help',self.help)

        self.help.insertItem('&About',self.about,Qt.Key_F1)
        self.help.insertItem('About &Qt',self.aboutQt)

        self.e = QMultiLineEdit(self,'editor')
        self.e.setFocus()
        self.setCentralWidget(self.e)

        self.statusBar().message('Ready',2000)
        self.resize(450,600)

    def newDoc(self):
        ed = ApplicationWindow()
        ed.show()
        editorList.append(ed)

    def load(self):
        fn = QFileDialog.getOpenFileName(QString.null,QString.null,self)
        if fn.isEmpty():
            self.statusBar().message('Loading aborted',2000)
            return

        fileName = str(fn)

        self.e.setAutoUpdate(0)
        self.e.clear()

        try:
            f = open(fileName,'r')
        except:
            return

        for l in f.readlines():
            self.e.append(string.rstrip(l))

        f.close()

        self.e.setAutoUpdate(1)
        self.e.repaint()
        self.e.setEdited(0)
        self.setCaption(fileName)
        self.statusBar().message('Loaded document %s' % (fileName),2000)

    def save(self):
        if self.filename.isEmpty():
            self.saveAs()
            return

        try:
            f = open(str(self.filename),'w+')
        except:
            self.statusBar().message('Could not write to %s' % (self.filename),2000)
            return

        f.write(str(self.e.text()))
        f.close()

        self.e.setEdited(0)
        self.setCaption(self.filename)
        self.statusBar().message('File %s saved' % (self.filename),2000)

    def saveAs(self):
        fn = QFileDialog.getSaveFileName(QString.null,QString.null,self)
        if not fn.isEmpty():
            self.filename = fn
            self.save()
        else:
            self.statusBar().message('Saving aborted',2000)

    def printDoc(self):
        Margin = 10
        pageNo = 1

        if self.printer.setup(self):
            self.statusBar().message('Printing...')

            p = QPainter()
            p.begin(self.printer)
            p.setFont(self.e.font())
            yPos = 0
            fm = p.fontMetrics()
            metrics = QPaintDeviceMetrics(self.printer)

            for i in range(self.e.numLines):
                if Margin + yPos > metrics.height() - Margin:
                    pageNo = pageNo + 1
                    self.statusBar().message('Printing (page %d)...' % (pageNo))
                    self.printer.newPage()
                    yPos = 0

                p.drawText(Margin,Margin + yPos,metrics.width(),fm.lineSpacing(),Qt.ExpandTabs | Qt.DontClip,self.e.textLine(i))
                yPos = yPos + fm.lineSpacing()

            p.end()
            self.statusBar().message('Printing completed',2000)
        else:
            self.statusBar().message('Printing aborted',2000)
 
    def closeEvent(self,ce):
        if not self.e.edited():
            ce.accept()
            return

        rc = QMessageBox.information(self,'Qt Application Example',
                    'The document has been changed since the last save.',
                    'Save Now','Cancel','Leave Anyway',0,1)

        if rc == 0:
            self.save()
            ce.accept()
        elif rc == 2:
            ce.accept()
        else:
            ce.ignore()

    def about(self):
        QMessageBox.about(self,'Qt Application Example',
            'This example demonstrates simple use of QMainWindow,\nQMenuBar and QToolBar.')

    def aboutQt(self):
        QMessageBox.aboutQt(self,'Qt Application Example')


a = QApplication(sys.argv)
mw = ApplicationWindow()
mw.setCaption('Document 1')
mw.show()
a.connect(a, SIGNAL('lastWindowClosed()'), a, SLOT('quit()'))
a.exec_loop()
